#include "test-file.h"
#include "test-file-mode_from_string.h"

#ifdef __cplusplus
extern "C" {
#endif

void test__f_file_mode_from_string__fails_basic(void **state) {

  f_string_static_t codes[] = {
    macro_f_string_static_t_initialize("+a", 0, 2),
    macro_f_string_static_t_initialize("-b", 0, 2),
    macro_f_string_static_t_initialize("=c", 0, 2),
    macro_f_string_static_t_initialize("++", 0, 2),
    macro_f_string_static_t_initialize("+-", 0, 2),
    macro_f_string_static_t_initialize("+=", 0, 2),
    macro_f_string_static_t_initialize("-+", 0, 2),
    macro_f_string_static_t_initialize("--", 0, 2),
    macro_f_string_static_t_initialize("-=", 0, 2),
    macro_f_string_static_t_initialize("=+", 0, 2),
    macro_f_string_static_t_initialize("=-", 0, 2),
    macro_f_string_static_t_initialize("==", 0, 2),
    macro_f_string_static_t_initialize("hijk", 0, 4),
    macro_f_string_static_t_initialize("lmno3", 0, 5),
    macro_f_string_static_t_initialize("u", 0, 1),
    macro_f_string_static_t_initialize("g", 0, 1),
    macro_f_string_static_t_initialize("o", 0, 1),
    macro_f_string_static_t_initialize("uu", 0, 2),
    macro_f_string_static_t_initialize("gu", 0, 2),
    macro_f_string_static_t_initialize("ou", 0, 2),
    macro_f_string_static_t_initialize("ug", 0, 2),
    macro_f_string_static_t_initialize("gg", 0, 2),
    macro_f_string_static_t_initialize("og", 0, 2),
    macro_f_string_static_t_initialize("uo", 0, 2),
    macro_f_string_static_t_initialize("go", 0, 2),
    macro_f_string_static_t_initialize("oo", 0, 2),
    macro_f_string_static_t_initialize("uuu", 0, 3),
    macro_f_string_static_t_initialize("guu", 0, 3),
    macro_f_string_static_t_initialize("ouu", 0, 3),
    macro_f_string_static_t_initialize("ugu", 0, 3),
    macro_f_string_static_t_initialize("ggu", 0, 3),
    macro_f_string_static_t_initialize("ogu", 0, 3),
    macro_f_string_static_t_initialize("uou", 0, 3),
    macro_f_string_static_t_initialize("gou", 0, 3),
    macro_f_string_static_t_initialize("oou", 0, 3),
    macro_f_string_static_t_initialize("uug", 0, 3),
    macro_f_string_static_t_initialize("gug", 0, 3),
    macro_f_string_static_t_initialize("oug", 0, 3),
    macro_f_string_static_t_initialize("ugg", 0, 3),
    macro_f_string_static_t_initialize("ggg", 0, 3),
    macro_f_string_static_t_initialize("ogg", 0, 3),
    macro_f_string_static_t_initialize("uog", 0, 3),
    macro_f_string_static_t_initialize("gog", 0, 3),
    macro_f_string_static_t_initialize("oog", 0, 3),
    macro_f_string_static_t_initialize("uuo", 0, 3),
    macro_f_string_static_t_initialize("guo", 0, 3),
    macro_f_string_static_t_initialize("ouo", 0, 3),
    macro_f_string_static_t_initialize("ugo", 0, 3),
    macro_f_string_static_t_initialize("ggo", 0, 3),
    macro_f_string_static_t_initialize("ogo", 0, 3),
    macro_f_string_static_t_initialize("uoo", 0, 3),
    macro_f_string_static_t_initialize("goo", 0, 3),
    macro_f_string_static_t_initialize("ooo", 0, 3),
    macro_f_string_static_t_initialize("u+", 0, 2),
    macro_f_string_static_t_initialize("g+", 0, 2),
    macro_f_string_static_t_initialize("o+", 0, 2),
    macro_f_string_static_t_initialize("u-", 0, 2),
    macro_f_string_static_t_initialize("g-", 0, 2),
    macro_f_string_static_t_initialize("o-", 0, 2),
    macro_f_string_static_t_initialize("u=", 0, 2),
    macro_f_string_static_t_initialize("g=", 0, 2),
    macro_f_string_static_t_initialize("o=", 0, 2),
    macro_f_string_static_t_initialize("u+r0", 0, 4),
    macro_f_string_static_t_initialize("g+r0", 0, 4),
    macro_f_string_static_t_initialize("o+r0", 0, 4),
    macro_f_string_static_t_initialize("u-w1", 0, 4),
    macro_f_string_static_t_initialize("g-w1", 0, 4),
    macro_f_string_static_t_initialize("o-w1", 0, 4),
    macro_f_string_static_t_initialize("u=2x", 0, 4),
    macro_f_string_static_t_initialize("g=2x", 0, 4),
    macro_f_string_static_t_initialize("o=2x", 0, 4),
    macro_f_string_static_t_initialize("012a", 0, 4),
    macro_f_string_static_t_initialize("351r", 0, 4),
    macro_f_string_static_t_initialize("5+x", 0, 3),
    macro_f_string_static_t_initialize("32425", 0, 5),
    macro_f_string_static_t_initialize("0000012345", 0, 10),
    macro_f_string_static_t_initialize("8", 0, 1),
    macro_f_string_static_t_initialize("9", 0, 1),
    macro_f_string_static_t_initialize("0+1", 0, 3),
    macro_f_string_static_t_initialize("0+r", 0, 3),
    macro_f_string_static_t_initialize("2+1", 0, 3),
    macro_f_string_static_t_initialize("2+r", 0, 3),
    macro_f_string_static_t_initialize("u+rwx", 0, 2),
    macro_f_string_static_t_initialize("u+r", 0, 4),
    macro_f_string_static_t_initialize("555", 0, 4),
  };

  f_status_t statuss[] = {
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
  };

  for (int i = 0; i < 85; ++i) {

    f_file_mode_t mode = 0;
    uint8_t replace = 0;

    const f_status_t status = f_file_mode_from_string(codes[i], 0, &mode, &replace);

    assert_int_equal(status, F_status_set_error(statuss[i]));
  } // for
}

void test__f_file_mode_from_string__parameter_checking(void **state) {

  {
    const f_status_t status = f_file_mode_from_string(f_string_empty_s, 0, 0, 0);

    assert_int_equal(status, F_status_set_error(F_parameter));
  }

  {
    f_file_mode_t mode_file = f_file_mode_t_initialize;

    const f_status_t status = f_file_mode_from_string(f_string_empty_s, 0, &mode_file, 0);

    assert_int_equal(status, F_status_set_error(F_parameter));
  }

  {
    uint8_t replace = 0;

    const f_status_t status = f_file_mode_from_string(f_string_empty_s, 0, 0, &replace);

    assert_int_equal(status, F_status_set_error(F_parameter));
  }
}

void test__f_file_mode_from_string__returns_data_not(void **state) {

    {
      f_file_mode_t mode_file = f_file_mode_t_initialize;
      uint8_t replace = 0;

      const f_status_t status = f_file_mode_from_string(f_string_empty_s, 0, &mode_file, &replace);

      assert_int_equal(F_status_set_fine(status), F_data_not);
    }
}

void test__f_file_mode_from_string__works_basic_alphabet(void **state) {

  f_string_static_t codes[] = {
    macro_f_string_static_t_initialize("+r", 0, 2),
    macro_f_string_static_t_initialize("-w", 0, 2),
    macro_f_string_static_t_initialize("=x", 0, 2),
    macro_f_string_static_t_initialize("+rw", 0, 3),
    macro_f_string_static_t_initialize("+rx", 0, 3),
    macro_f_string_static_t_initialize("+wr", 0, 3),
    macro_f_string_static_t_initialize("+wx", 0, 3),
    macro_f_string_static_t_initialize("+xr", 0, 3),
    macro_f_string_static_t_initialize("+xw", 0, 3),
    macro_f_string_static_t_initialize("-rw", 0, 3),
    macro_f_string_static_t_initialize("-rx", 0, 3),
    macro_f_string_static_t_initialize("-wr", 0, 3),
    macro_f_string_static_t_initialize("-wx", 0, 3),
    macro_f_string_static_t_initialize("-xr", 0, 3),
    macro_f_string_static_t_initialize("-xw", 0, 3),
    macro_f_string_static_t_initialize("=rw", 0, 3),
    macro_f_string_static_t_initialize("=rx", 0, 3),
    macro_f_string_static_t_initialize("=wr", 0, 3),
    macro_f_string_static_t_initialize("=wx", 0, 3),
    macro_f_string_static_t_initialize("=xr", 0, 3),
    macro_f_string_static_t_initialize("=xw", 0, 3),
    macro_f_string_static_t_initialize("+rwx", 0, 4),
    macro_f_string_static_t_initialize("+wrx", 0, 4),
    macro_f_string_static_t_initialize("+wxr", 0, 4),
    macro_f_string_static_t_initialize("+rxw", 0, 4),
    macro_f_string_static_t_initialize("+wxr", 0, 4),
    macro_f_string_static_t_initialize("+xwr", 0, 4),
    macro_f_string_static_t_initialize("+xrw", 0, 4),
    macro_f_string_static_t_initialize("-rwx", 0, 4),
    macro_f_string_static_t_initialize("-wrx", 0, 4),
    macro_f_string_static_t_initialize("-wxr", 0, 4),
    macro_f_string_static_t_initialize("-rxw", 0, 4),
    macro_f_string_static_t_initialize("-wxr", 0, 4),
    macro_f_string_static_t_initialize("-xwr", 0, 4),
    macro_f_string_static_t_initialize("-xrw", 0, 4),
    macro_f_string_static_t_initialize("=rwx", 0, 4),
    macro_f_string_static_t_initialize("=wrx", 0, 4),
    macro_f_string_static_t_initialize("=wxr", 0, 4),
    macro_f_string_static_t_initialize("=rxw", 0, 4),
    macro_f_string_static_t_initialize("=wxr", 0, 4),
    macro_f_string_static_t_initialize("=xwr", 0, 4),
    macro_f_string_static_t_initialize("=xrw", 0, 4),
    macro_f_string_static_t_initialize("u+rw", 0, 4),
    macro_f_string_static_t_initialize("u+rx", 0, 4),
    macro_f_string_static_t_initialize("u+wr", 0, 4),
    macro_f_string_static_t_initialize("u+wx", 0, 4),
    macro_f_string_static_t_initialize("u+xr", 0, 4),
    macro_f_string_static_t_initialize("u+xw", 0, 4),
    macro_f_string_static_t_initialize("u-rw", 0, 4),
    macro_f_string_static_t_initialize("u-rx", 0, 4),
    macro_f_string_static_t_initialize("u-wr", 0, 4),
    macro_f_string_static_t_initialize("u-wx", 0, 4),
    macro_f_string_static_t_initialize("u-xr", 0, 4),
    macro_f_string_static_t_initialize("u-xw", 0, 4),
    macro_f_string_static_t_initialize("u=rw", 0, 4),
    macro_f_string_static_t_initialize("u=rx", 0, 4),
    macro_f_string_static_t_initialize("u=wr", 0, 4),
    macro_f_string_static_t_initialize("u=wx", 0, 4),
    macro_f_string_static_t_initialize("u=xr", 0, 4),
    macro_f_string_static_t_initialize("u=xw", 0, 4),
    macro_f_string_static_t_initialize("u+rwx", 0, 5),
    macro_f_string_static_t_initialize("u+wrx", 0, 5),
    macro_f_string_static_t_initialize("u+wxr", 0, 5),
    macro_f_string_static_t_initialize("u+rxw", 0, 5),
    macro_f_string_static_t_initialize("u+wxr", 0, 5),
    macro_f_string_static_t_initialize("u+xwr", 0, 5),
    macro_f_string_static_t_initialize("u+xrw", 0, 5),
    macro_f_string_static_t_initialize("u-rwx", 0, 5),
    macro_f_string_static_t_initialize("u-wrx", 0, 5),
    macro_f_string_static_t_initialize("u-wxr", 0, 5),
    macro_f_string_static_t_initialize("u-rxw", 0, 5),
    macro_f_string_static_t_initialize("u-wxr", 0, 5),
    macro_f_string_static_t_initialize("u-xwr", 0, 5),
    macro_f_string_static_t_initialize("u-xrw", 0, 5),
    macro_f_string_static_t_initialize("u=rwx", 0, 5),
    macro_f_string_static_t_initialize("u=wrx", 0, 5),
    macro_f_string_static_t_initialize("u=wxr", 0, 5),
    macro_f_string_static_t_initialize("u=rxw", 0, 5),
    macro_f_string_static_t_initialize("u=wxr", 0, 5),
    macro_f_string_static_t_initialize("u=xwr", 0, 5),
    macro_f_string_static_t_initialize("u=xrw", 0, 5),
    macro_f_string_static_t_initialize("g+rw", 0, 4),
    macro_f_string_static_t_initialize("g+rx", 0, 4),
    macro_f_string_static_t_initialize("g+wr", 0, 4),
    macro_f_string_static_t_initialize("g+wx", 0, 4),
    macro_f_string_static_t_initialize("g+xr", 0, 4),
    macro_f_string_static_t_initialize("g+xw", 0, 4),
    macro_f_string_static_t_initialize("g-rw", 0, 4),
    macro_f_string_static_t_initialize("g-rx", 0, 4),
    macro_f_string_static_t_initialize("g-wr", 0, 4),
    macro_f_string_static_t_initialize("g-wx", 0, 4),
    macro_f_string_static_t_initialize("g-xr", 0, 4),
    macro_f_string_static_t_initialize("g-xw", 0, 4),
    macro_f_string_static_t_initialize("g=rw", 0, 4),
    macro_f_string_static_t_initialize("g=rx", 0, 4),
    macro_f_string_static_t_initialize("g=wr", 0, 4),
    macro_f_string_static_t_initialize("g=wx", 0, 4),
    macro_f_string_static_t_initialize("g=xr", 0, 4),
    macro_f_string_static_t_initialize("g=xw", 0, 4),
    macro_f_string_static_t_initialize("g+rwx", 0, 5),
    macro_f_string_static_t_initialize("g+wrx", 0, 5),
    macro_f_string_static_t_initialize("g+wxr", 0, 5),
    macro_f_string_static_t_initialize("g+rxw", 0, 5),
    macro_f_string_static_t_initialize("g+wxr", 0, 5),
    macro_f_string_static_t_initialize("g+xwr", 0, 5),
    macro_f_string_static_t_initialize("g+xrw", 0, 5),
    macro_f_string_static_t_initialize("g-rwx", 0, 5),
    macro_f_string_static_t_initialize("g-wrx", 0, 5),
    macro_f_string_static_t_initialize("g-wxr", 0, 5),
    macro_f_string_static_t_initialize("g-rxw", 0, 5),
    macro_f_string_static_t_initialize("g-wxr", 0, 5),
    macro_f_string_static_t_initialize("g-xwr", 0, 5),
    macro_f_string_static_t_initialize("g-xrw", 0, 5),
    macro_f_string_static_t_initialize("g=rwx", 0, 5),
    macro_f_string_static_t_initialize("g=wrx", 0, 5),
    macro_f_string_static_t_initialize("g=wxr", 0, 5),
    macro_f_string_static_t_initialize("g=rxw", 0, 5),
    macro_f_string_static_t_initialize("g=wxr", 0, 5),
    macro_f_string_static_t_initialize("g=xwr", 0, 5),
    macro_f_string_static_t_initialize("g=xrw", 0, 5),
    macro_f_string_static_t_initialize("o+rw", 0, 4),
    macro_f_string_static_t_initialize("o+rx", 0, 4),
    macro_f_string_static_t_initialize("o+wr", 0, 4),
    macro_f_string_static_t_initialize("o+wx", 0, 4),
    macro_f_string_static_t_initialize("o+xr", 0, 4),
    macro_f_string_static_t_initialize("o+xw", 0, 4),
    macro_f_string_static_t_initialize("o-rw", 0, 4),
    macro_f_string_static_t_initialize("o-rx", 0, 4),
    macro_f_string_static_t_initialize("o-wr", 0, 4),
    macro_f_string_static_t_initialize("o-wx", 0, 4),
    macro_f_string_static_t_initialize("o-xr", 0, 4),
    macro_f_string_static_t_initialize("o-xw", 0, 4),
    macro_f_string_static_t_initialize("o=rw", 0, 4),
    macro_f_string_static_t_initialize("o=rx", 0, 4),
    macro_f_string_static_t_initialize("o=wr", 0, 4),
    macro_f_string_static_t_initialize("o=wx", 0, 4),
    macro_f_string_static_t_initialize("o=xr", 0, 4),
    macro_f_string_static_t_initialize("o=xw", 0, 4),
    macro_f_string_static_t_initialize("o+rwx", 0, 5),
    macro_f_string_static_t_initialize("o+wrx", 0, 5),
    macro_f_string_static_t_initialize("o+wxr", 0, 5),
    macro_f_string_static_t_initialize("o+rxw", 0, 5),
    macro_f_string_static_t_initialize("o+wxr", 0, 5),
    macro_f_string_static_t_initialize("o+xwr", 0, 5),
    macro_f_string_static_t_initialize("o+xrw", 0, 5),
    macro_f_string_static_t_initialize("o-rwx", 0, 5),
    macro_f_string_static_t_initialize("o-wrx", 0, 5),
    macro_f_string_static_t_initialize("o-wxr", 0, 5),
    macro_f_string_static_t_initialize("o-rxw", 0, 5),
    macro_f_string_static_t_initialize("o-wxr", 0, 5),
    macro_f_string_static_t_initialize("o-xwr", 0, 5),
    macro_f_string_static_t_initialize("o-xrw", 0, 5),
    macro_f_string_static_t_initialize("o=rwx", 0, 5),
    macro_f_string_static_t_initialize("o=wrx", 0, 5),
    macro_f_string_static_t_initialize("o=wxr", 0, 5),
    macro_f_string_static_t_initialize("o=rxw", 0, 5),
    macro_f_string_static_t_initialize("o=wxr", 0, 5),
    macro_f_string_static_t_initialize("o=xwr", 0, 5),
    macro_f_string_static_t_initialize("o=xrw", 0, 5),
    macro_f_string_static_t_initialize("ug+rw", 0, 5),
    macro_f_string_static_t_initialize("ug+rx", 0, 5),
    macro_f_string_static_t_initialize("ug+wr", 0, 5),
    macro_f_string_static_t_initialize("ug+wx", 0, 5),
    macro_f_string_static_t_initialize("ug+xr", 0, 5),
    macro_f_string_static_t_initialize("ug+xw", 0, 5),
    macro_f_string_static_t_initialize("ug-rw", 0, 5),
    macro_f_string_static_t_initialize("ug-rx", 0, 5),
    macro_f_string_static_t_initialize("ug-wr", 0, 5),
    macro_f_string_static_t_initialize("ug-wx", 0, 5),
    macro_f_string_static_t_initialize("ug-xr", 0, 5),
    macro_f_string_static_t_initialize("ug-xw", 0, 5),
    macro_f_string_static_t_initialize("ug=rw", 0, 5),
    macro_f_string_static_t_initialize("ug=rx", 0, 5),
    macro_f_string_static_t_initialize("ug=wr", 0, 5),
    macro_f_string_static_t_initialize("ug=wx", 0, 5),
    macro_f_string_static_t_initialize("ug=xr", 0, 5),
    macro_f_string_static_t_initialize("ug=xw", 0, 5),
    macro_f_string_static_t_initialize("ug+rwx", 0, 6),
    macro_f_string_static_t_initialize("ug+wrx", 0, 6),
    macro_f_string_static_t_initialize("ug+wxr", 0, 6),
    macro_f_string_static_t_initialize("ug+rxw", 0, 6),
    macro_f_string_static_t_initialize("ug+wxr", 0, 6),
    macro_f_string_static_t_initialize("ug+xwr", 0, 6),
    macro_f_string_static_t_initialize("ug+xrw", 0, 6),
    macro_f_string_static_t_initialize("ug-rwx", 0, 6),
    macro_f_string_static_t_initialize("ug-wrx", 0, 6),
    macro_f_string_static_t_initialize("ug-wxr", 0, 6),
    macro_f_string_static_t_initialize("ug-rxw", 0, 6),
    macro_f_string_static_t_initialize("ug-wxr", 0, 6),
    macro_f_string_static_t_initialize("ug-xwr", 0, 6),
    macro_f_string_static_t_initialize("ug-xrw", 0, 6),
    macro_f_string_static_t_initialize("ug=rwx", 0, 6),
    macro_f_string_static_t_initialize("ug=wrx", 0, 6),
    macro_f_string_static_t_initialize("ug=wxr", 0, 6),
    macro_f_string_static_t_initialize("ug=rxw", 0, 6),
    macro_f_string_static_t_initialize("ug=wxr", 0, 6),
    macro_f_string_static_t_initialize("ug=xwr", 0, 6),
    macro_f_string_static_t_initialize("ug=xrw", 0, 6),
    macro_f_string_static_t_initialize("uo+rw", 0, 5),
    macro_f_string_static_t_initialize("uo+rx", 0, 5),
    macro_f_string_static_t_initialize("uo+wr", 0, 5),
    macro_f_string_static_t_initialize("uo+wx", 0, 5),
    macro_f_string_static_t_initialize("uo+xr", 0, 5),
    macro_f_string_static_t_initialize("uo+xw", 0, 5),
    macro_f_string_static_t_initialize("uo-rw", 0, 5),
    macro_f_string_static_t_initialize("uo-rx", 0, 5),
    macro_f_string_static_t_initialize("uo-wr", 0, 5),
    macro_f_string_static_t_initialize("uo-wx", 0, 5),
    macro_f_string_static_t_initialize("uo-xr", 0, 5),
    macro_f_string_static_t_initialize("uo-xw", 0, 5),
    macro_f_string_static_t_initialize("uo=rw", 0, 5),
    macro_f_string_static_t_initialize("uo=rx", 0, 5),
    macro_f_string_static_t_initialize("uo=wr", 0, 5),
    macro_f_string_static_t_initialize("uo=wx", 0, 5),
    macro_f_string_static_t_initialize("uo=xr", 0, 5),
    macro_f_string_static_t_initialize("uo=xw", 0, 5),
    macro_f_string_static_t_initialize("uo+rwx", 0, 6),
    macro_f_string_static_t_initialize("uo+wrx", 0, 6),
    macro_f_string_static_t_initialize("uo+wxr", 0, 6),
    macro_f_string_static_t_initialize("uo+rxw", 0, 6),
    macro_f_string_static_t_initialize("uo+wxr", 0, 6),
    macro_f_string_static_t_initialize("uo+xwr", 0, 6),
    macro_f_string_static_t_initialize("uo+xrw", 0, 6),
    macro_f_string_static_t_initialize("uo-rwx", 0, 6),
    macro_f_string_static_t_initialize("uo-wrx", 0, 6),
    macro_f_string_static_t_initialize("uo-wxr", 0, 6),
    macro_f_string_static_t_initialize("uo-rxw", 0, 6),
    macro_f_string_static_t_initialize("uo-wxr", 0, 6),
    macro_f_string_static_t_initialize("uo-xwr", 0, 6),
    macro_f_string_static_t_initialize("uo-xrw", 0, 6),
    macro_f_string_static_t_initialize("uo=rwx", 0, 6),
    macro_f_string_static_t_initialize("uo=wrx", 0, 6),
    macro_f_string_static_t_initialize("uo=wxr", 0, 6),
    macro_f_string_static_t_initialize("uo=rxw", 0, 6),
    macro_f_string_static_t_initialize("uo=wxr", 0, 6),
    macro_f_string_static_t_initialize("uo=xwr", 0, 6),
    macro_f_string_static_t_initialize("uo=xrw", 0, 6),
    macro_f_string_static_t_initialize("gu+rw", 0, 5),
    macro_f_string_static_t_initialize("gu+rx", 0, 5),
    macro_f_string_static_t_initialize("gu+wr", 0, 5),
    macro_f_string_static_t_initialize("gu+wx", 0, 5),
    macro_f_string_static_t_initialize("gu+xr", 0, 5),
    macro_f_string_static_t_initialize("gu+xw", 0, 5),
    macro_f_string_static_t_initialize("gu-rw", 0, 5),
    macro_f_string_static_t_initialize("gu-rx", 0, 5),
    macro_f_string_static_t_initialize("gu-wr", 0, 5),
    macro_f_string_static_t_initialize("gu-wx", 0, 5),
    macro_f_string_static_t_initialize("gu-xr", 0, 5),
    macro_f_string_static_t_initialize("gu-xw", 0, 5),
    macro_f_string_static_t_initialize("gu=rw", 0, 5),
    macro_f_string_static_t_initialize("gu=rx", 0, 5),
    macro_f_string_static_t_initialize("gu=wr", 0, 5),
    macro_f_string_static_t_initialize("gu=wx", 0, 5),
    macro_f_string_static_t_initialize("gu=xr", 0, 5),
    macro_f_string_static_t_initialize("gu=xw", 0, 5),
    macro_f_string_static_t_initialize("gu+rwx", 0, 6),
    macro_f_string_static_t_initialize("gu+wrx", 0, 6),
    macro_f_string_static_t_initialize("gu+wxr", 0, 6),
    macro_f_string_static_t_initialize("gu+rxw", 0, 6),
    macro_f_string_static_t_initialize("gu+wxr", 0, 6),
    macro_f_string_static_t_initialize("gu+xwr", 0, 6),
    macro_f_string_static_t_initialize("gu+xrw", 0, 6),
    macro_f_string_static_t_initialize("gu-rwx", 0, 6),
    macro_f_string_static_t_initialize("gu-wrx", 0, 6),
    macro_f_string_static_t_initialize("gu-wxr", 0, 6),
    macro_f_string_static_t_initialize("gu-rxw", 0, 6),
    macro_f_string_static_t_initialize("gu-wxr", 0, 6),
    macro_f_string_static_t_initialize("gu-xwr", 0, 6),
    macro_f_string_static_t_initialize("gu-xrw", 0, 6),
    macro_f_string_static_t_initialize("gu=rwx", 0, 6),
    macro_f_string_static_t_initialize("gu=wrx", 0, 6),
    macro_f_string_static_t_initialize("gu=wxr", 0, 6),
    macro_f_string_static_t_initialize("gu=rxw", 0, 6),
    macro_f_string_static_t_initialize("gu=wxr", 0, 6),
    macro_f_string_static_t_initialize("gu=xwr", 0, 6),
    macro_f_string_static_t_initialize("gu=xrw", 0, 6),
    macro_f_string_static_t_initialize("go+rw", 0, 5),
    macro_f_string_static_t_initialize("go+rx", 0, 5),
    macro_f_string_static_t_initialize("go+wr", 0, 5),
    macro_f_string_static_t_initialize("go+wx", 0, 5),
    macro_f_string_static_t_initialize("go+xr", 0, 5),
    macro_f_string_static_t_initialize("go+xw", 0, 5),
    macro_f_string_static_t_initialize("go-rw", 0, 5),
    macro_f_string_static_t_initialize("go-rx", 0, 5),
    macro_f_string_static_t_initialize("go-wr", 0, 5),
    macro_f_string_static_t_initialize("go-wx", 0, 5),
    macro_f_string_static_t_initialize("go-xr", 0, 5),
    macro_f_string_static_t_initialize("go-xw", 0, 5),
    macro_f_string_static_t_initialize("go=rw", 0, 5),
    macro_f_string_static_t_initialize("go=rx", 0, 5),
    macro_f_string_static_t_initialize("go=wr", 0, 5),
    macro_f_string_static_t_initialize("go=wx", 0, 5),
    macro_f_string_static_t_initialize("go=xr", 0, 5),
    macro_f_string_static_t_initialize("go=xw", 0, 5),
    macro_f_string_static_t_initialize("go+rwx", 0, 6),
    macro_f_string_static_t_initialize("go+wrx", 0, 6),
    macro_f_string_static_t_initialize("go+wxr", 0, 6),
    macro_f_string_static_t_initialize("go+rxw", 0, 6),
    macro_f_string_static_t_initialize("go+wxr", 0, 6),
    macro_f_string_static_t_initialize("go+xwr", 0, 6),
    macro_f_string_static_t_initialize("go+xrw", 0, 6),
    macro_f_string_static_t_initialize("go-rwx", 0, 6),
    macro_f_string_static_t_initialize("go-wrx", 0, 6),
    macro_f_string_static_t_initialize("go-wxr", 0, 6),
    macro_f_string_static_t_initialize("go-rxw", 0, 6),
    macro_f_string_static_t_initialize("go-wxr", 0, 6),
    macro_f_string_static_t_initialize("go-xwr", 0, 6),
    macro_f_string_static_t_initialize("go-xrw", 0, 6),
    macro_f_string_static_t_initialize("go=rwx", 0, 6),
    macro_f_string_static_t_initialize("go=wrx", 0, 6),
    macro_f_string_static_t_initialize("go=wxr", 0, 6),
    macro_f_string_static_t_initialize("go=rxw", 0, 6),
    macro_f_string_static_t_initialize("go=wxr", 0, 6),
    macro_f_string_static_t_initialize("go=xwr", 0, 6),
    macro_f_string_static_t_initialize("go=xrw", 0, 6),
    macro_f_string_static_t_initialize("ou+rw", 0, 5),
    macro_f_string_static_t_initialize("ou+rx", 0, 5),
    macro_f_string_static_t_initialize("ou+wr", 0, 5),
    macro_f_string_static_t_initialize("ou+wx", 0, 5),
    macro_f_string_static_t_initialize("ou+xr", 0, 5),
    macro_f_string_static_t_initialize("ou+xw", 0, 5),
    macro_f_string_static_t_initialize("ou-rw", 0, 5),
    macro_f_string_static_t_initialize("ou-rx", 0, 5),
    macro_f_string_static_t_initialize("ou-wr", 0, 5),
    macro_f_string_static_t_initialize("ou-wx", 0, 5),
    macro_f_string_static_t_initialize("ou-xr", 0, 5),
    macro_f_string_static_t_initialize("ou-xw", 0, 5),
    macro_f_string_static_t_initialize("ou=rw", 0, 5),
    macro_f_string_static_t_initialize("ou=rx", 0, 5),
    macro_f_string_static_t_initialize("ou=wr", 0, 5),
    macro_f_string_static_t_initialize("ou=wx", 0, 5),
    macro_f_string_static_t_initialize("ou=xr", 0, 5),
    macro_f_string_static_t_initialize("ou=xw", 0, 5),
    macro_f_string_static_t_initialize("ou+rwx", 0, 6),
    macro_f_string_static_t_initialize("ou+wrx", 0, 6),
    macro_f_string_static_t_initialize("ou+wxr", 0, 6),
    macro_f_string_static_t_initialize("ou+rxw", 0, 6),
    macro_f_string_static_t_initialize("ou+wxr", 0, 6),
    macro_f_string_static_t_initialize("ou+xwr", 0, 6),
    macro_f_string_static_t_initialize("ou+xrw", 0, 6),
    macro_f_string_static_t_initialize("ou-rwx", 0, 6),
    macro_f_string_static_t_initialize("ou-wrx", 0, 6),
    macro_f_string_static_t_initialize("ou-wxr", 0, 6),
    macro_f_string_static_t_initialize("ou-rxw", 0, 6),
    macro_f_string_static_t_initialize("ou-wxr", 0, 6),
    macro_f_string_static_t_initialize("ou-xwr", 0, 6),
    macro_f_string_static_t_initialize("ou-xrw", 0, 6),
    macro_f_string_static_t_initialize("ou=rwx", 0, 6),
    macro_f_string_static_t_initialize("ou=wrx", 0, 6),
    macro_f_string_static_t_initialize("ou=wxr", 0, 6),
    macro_f_string_static_t_initialize("ou=rxw", 0, 6),
    macro_f_string_static_t_initialize("ou=wxr", 0, 6),
    macro_f_string_static_t_initialize("ou=xwr", 0, 6),
    macro_f_string_static_t_initialize("ou=xrw", 0, 6),
    macro_f_string_static_t_initialize("og+rw", 0, 5),
    macro_f_string_static_t_initialize("og+rx", 0, 5),
    macro_f_string_static_t_initialize("og+wr", 0, 5),
    macro_f_string_static_t_initialize("og+wx", 0, 5),
    macro_f_string_static_t_initialize("og+xr", 0, 5),
    macro_f_string_static_t_initialize("og+xw", 0, 5),
    macro_f_string_static_t_initialize("og-rw", 0, 5),
    macro_f_string_static_t_initialize("og-rx", 0, 5),
    macro_f_string_static_t_initialize("og-wr", 0, 5),
    macro_f_string_static_t_initialize("og-wx", 0, 5),
    macro_f_string_static_t_initialize("og-xr", 0, 5),
    macro_f_string_static_t_initialize("og-xw", 0, 5),
    macro_f_string_static_t_initialize("og=rw", 0, 5),
    macro_f_string_static_t_initialize("og=rx", 0, 5),
    macro_f_string_static_t_initialize("og=wr", 0, 5),
    macro_f_string_static_t_initialize("og=wx", 0, 5),
    macro_f_string_static_t_initialize("og=xr", 0, 5),
    macro_f_string_static_t_initialize("og=xw", 0, 5),
    macro_f_string_static_t_initialize("og+rwx", 0, 6),
    macro_f_string_static_t_initialize("og+wrx", 0, 6),
    macro_f_string_static_t_initialize("og+wxr", 0, 6),
    macro_f_string_static_t_initialize("og+rxw", 0, 6),
    macro_f_string_static_t_initialize("og+wxr", 0, 6),
    macro_f_string_static_t_initialize("og+xwr", 0, 6),
    macro_f_string_static_t_initialize("og+xrw", 0, 6),
    macro_f_string_static_t_initialize("og-rwx", 0, 6),
    macro_f_string_static_t_initialize("og-wrx", 0, 6),
    macro_f_string_static_t_initialize("og-wxr", 0, 6),
    macro_f_string_static_t_initialize("og-rxw", 0, 6),
    macro_f_string_static_t_initialize("og-wxr", 0, 6),
    macro_f_string_static_t_initialize("og-xwr", 0, 6),
    macro_f_string_static_t_initialize("og-xrw", 0, 6),
    macro_f_string_static_t_initialize("og=rwx", 0, 6),
    macro_f_string_static_t_initialize("og=wrx", 0, 6),
    macro_f_string_static_t_initialize("og=wxr", 0, 6),
    macro_f_string_static_t_initialize("og=rxw", 0, 6),
    macro_f_string_static_t_initialize("og=wxr", 0, 6),
    macro_f_string_static_t_initialize("og=xwr", 0, 6),
    macro_f_string_static_t_initialize("og=xrw", 0, 6),
    macro_f_string_static_t_initialize("ugo+rw", 0, 6),
    macro_f_string_static_t_initialize("ugo+rx", 0, 6),
    macro_f_string_static_t_initialize("ugo+wr", 0, 6),
    macro_f_string_static_t_initialize("ugo+wx", 0, 6),
    macro_f_string_static_t_initialize("ugo+xr", 0, 6),
    macro_f_string_static_t_initialize("ugo+xw", 0, 6),
    macro_f_string_static_t_initialize("ugo-rw", 0, 6),
    macro_f_string_static_t_initialize("ugo-rx", 0, 6),
    macro_f_string_static_t_initialize("ugo-wr", 0, 6),
    macro_f_string_static_t_initialize("ugo-wx", 0, 6),
    macro_f_string_static_t_initialize("ugo-xr", 0, 6),
    macro_f_string_static_t_initialize("ugo-xw", 0, 6),
    macro_f_string_static_t_initialize("ugo=rw", 0, 6),
    macro_f_string_static_t_initialize("ugo=rx", 0, 6),
    macro_f_string_static_t_initialize("ugo=wr", 0, 6),
    macro_f_string_static_t_initialize("ugo=wx", 0, 6),
    macro_f_string_static_t_initialize("ugo=xr", 0, 6),
    macro_f_string_static_t_initialize("ugo=xw", 0, 6),
    macro_f_string_static_t_initialize("ugo+rwx", 0, 7),
    macro_f_string_static_t_initialize("ugo+wrx", 0, 7),
    macro_f_string_static_t_initialize("ugo+wxr", 0, 7),
    macro_f_string_static_t_initialize("ugo+rxw", 0, 7),
    macro_f_string_static_t_initialize("ugo+wxr", 0, 7),
    macro_f_string_static_t_initialize("ugo+xwr", 0, 7),
    macro_f_string_static_t_initialize("ugo+xrw", 0, 7),
    macro_f_string_static_t_initialize("ugo-rwx", 0, 7),
    macro_f_string_static_t_initialize("ugo-wrx", 0, 7),
    macro_f_string_static_t_initialize("ugo-wxr", 0, 7),
    macro_f_string_static_t_initialize("ugo-rxw", 0, 7),
    macro_f_string_static_t_initialize("ugo-wxr", 0, 7),
    macro_f_string_static_t_initialize("ugo-xwr", 0, 7),
    macro_f_string_static_t_initialize("ugo-xrw", 0, 7),
    macro_f_string_static_t_initialize("ugo=rwx", 0, 7),
    macro_f_string_static_t_initialize("ugo=wrx", 0, 7),
    macro_f_string_static_t_initialize("ugo=wxr", 0, 7),
    macro_f_string_static_t_initialize("ugo=rxw", 0, 7),
    macro_f_string_static_t_initialize("ugo=wxr", 0, 7),
    macro_f_string_static_t_initialize("ugo=xwr", 0, 7),
    macro_f_string_static_t_initialize("ugo=xrw", 0, 7),
    macro_f_string_static_t_initialize("guo+rwx", 0, 7),
    macro_f_string_static_t_initialize("guo+wrx", 0, 7),
    macro_f_string_static_t_initialize("guo+wxr", 0, 7),
    macro_f_string_static_t_initialize("guo+rxw", 0, 7),
    macro_f_string_static_t_initialize("guo+wxr", 0, 7),
    macro_f_string_static_t_initialize("guo+xwr", 0, 7),
    macro_f_string_static_t_initialize("guo+xrw", 0, 7),
    macro_f_string_static_t_initialize("guo-rwx", 0, 7),
    macro_f_string_static_t_initialize("guo-wrx", 0, 7),
    macro_f_string_static_t_initialize("guo-wxr", 0, 7),
    macro_f_string_static_t_initialize("guo-rxw", 0, 7),
    macro_f_string_static_t_initialize("guo-wxr", 0, 7),
    macro_f_string_static_t_initialize("guo-xwr", 0, 7),
    macro_f_string_static_t_initialize("guo-xrw", 0, 7),
    macro_f_string_static_t_initialize("guo=rwx", 0, 7),
    macro_f_string_static_t_initialize("guo=wrx", 0, 7),
    macro_f_string_static_t_initialize("guo=wxr", 0, 7),
    macro_f_string_static_t_initialize("guo=rxw", 0, 7),
    macro_f_string_static_t_initialize("guo=wxr", 0, 7),
    macro_f_string_static_t_initialize("guo=xwr", 0, 7),
    macro_f_string_static_t_initialize("guo=xrw", 0, 7),
    macro_f_string_static_t_initialize("gou+rwx", 0, 7),
    macro_f_string_static_t_initialize("gou+wrx", 0, 7),
    macro_f_string_static_t_initialize("gou+wxr", 0, 7),
    macro_f_string_static_t_initialize("gou+rxw", 0, 7),
    macro_f_string_static_t_initialize("gou+wxr", 0, 7),
    macro_f_string_static_t_initialize("gou+xwr", 0, 7),
    macro_f_string_static_t_initialize("gou+xrw", 0, 7),
    macro_f_string_static_t_initialize("gou-rwx", 0, 7),
    macro_f_string_static_t_initialize("gou-wrx", 0, 7),
    macro_f_string_static_t_initialize("gou-wxr", 0, 7),
    macro_f_string_static_t_initialize("gou-rxw", 0, 7),
    macro_f_string_static_t_initialize("gou-wxr", 0, 7),
    macro_f_string_static_t_initialize("gou-xwr", 0, 7),
    macro_f_string_static_t_initialize("gou-xrw", 0, 7),
    macro_f_string_static_t_initialize("gou=rwx", 0, 7),
    macro_f_string_static_t_initialize("gou=wrx", 0, 7),
    macro_f_string_static_t_initialize("gou=wxr", 0, 7),
    macro_f_string_static_t_initialize("gou=rxw", 0, 7),
    macro_f_string_static_t_initialize("gou=wxr", 0, 7),
    macro_f_string_static_t_initialize("gou=xwr", 0, 7),
    macro_f_string_static_t_initialize("gou=xrw", 0, 7),
    macro_f_string_static_t_initialize("guo+rwx", 0, 7),
    macro_f_string_static_t_initialize("guo+wrx", 0, 7),
    macro_f_string_static_t_initialize("guo+wxr", 0, 7),
    macro_f_string_static_t_initialize("guo+rxw", 0, 7),
    macro_f_string_static_t_initialize("guo+wxr", 0, 7),
    macro_f_string_static_t_initialize("guo+xwr", 0, 7),
    macro_f_string_static_t_initialize("guo+xrw", 0, 7),
    macro_f_string_static_t_initialize("guo-rwx", 0, 7),
    macro_f_string_static_t_initialize("guo-wrx", 0, 7),
    macro_f_string_static_t_initialize("guo-wxr", 0, 7),
    macro_f_string_static_t_initialize("guo-rxw", 0, 7),
    macro_f_string_static_t_initialize("guo-wxr", 0, 7),
    macro_f_string_static_t_initialize("guo-xwr", 0, 7),
    macro_f_string_static_t_initialize("guo-xrw", 0, 7),
    macro_f_string_static_t_initialize("guo=rwx", 0, 7),
    macro_f_string_static_t_initialize("guo=wrx", 0, 7),
    macro_f_string_static_t_initialize("guo=wxr", 0, 7),
    macro_f_string_static_t_initialize("guo=rxw", 0, 7),
    macro_f_string_static_t_initialize("guo=wxr", 0, 7),
    macro_f_string_static_t_initialize("guo=xwr", 0, 7),
    macro_f_string_static_t_initialize("guo=xrw", 0, 7),
    macro_f_string_static_t_initialize("uog+rwx", 0, 7),
    macro_f_string_static_t_initialize("uog+wrx", 0, 7),
    macro_f_string_static_t_initialize("uog+wxr", 0, 7),
    macro_f_string_static_t_initialize("uog+rxw", 0, 7),
    macro_f_string_static_t_initialize("uog+wxr", 0, 7),
    macro_f_string_static_t_initialize("uog+xwr", 0, 7),
    macro_f_string_static_t_initialize("uog+xrw", 0, 7),
    macro_f_string_static_t_initialize("uog-rwx", 0, 7),
    macro_f_string_static_t_initialize("uog-wrx", 0, 7),
    macro_f_string_static_t_initialize("uog-wxr", 0, 7),
    macro_f_string_static_t_initialize("uog-rxw", 0, 7),
    macro_f_string_static_t_initialize("uog-wxr", 0, 7),
    macro_f_string_static_t_initialize("uog-xwr", 0, 7),
    macro_f_string_static_t_initialize("uog-xrw", 0, 7),
    macro_f_string_static_t_initialize("uog=rwx", 0, 7),
    macro_f_string_static_t_initialize("uog=wrx", 0, 7),
    macro_f_string_static_t_initialize("uog=wxr", 0, 7),
    macro_f_string_static_t_initialize("uog=rxw", 0, 7),
    macro_f_string_static_t_initialize("uog=wxr", 0, 7),
    macro_f_string_static_t_initialize("uog=xwr", 0, 7),
    macro_f_string_static_t_initialize("uog=xrw", 0, 7),
    macro_f_string_static_t_initialize("oug+rwx", 0, 7),
    macro_f_string_static_t_initialize("oug+wrx", 0, 7),
    macro_f_string_static_t_initialize("oug+wxr", 0, 7),
    macro_f_string_static_t_initialize("oug+rxw", 0, 7),
    macro_f_string_static_t_initialize("oug+wxr", 0, 7),
    macro_f_string_static_t_initialize("oug+xwr", 0, 7),
    macro_f_string_static_t_initialize("oug+xrw", 0, 7),
    macro_f_string_static_t_initialize("oug-rwx", 0, 7),
    macro_f_string_static_t_initialize("oug-wrx", 0, 7),
    macro_f_string_static_t_initialize("oug-wxr", 0, 7),
    macro_f_string_static_t_initialize("oug-rxw", 0, 7),
    macro_f_string_static_t_initialize("oug-wxr", 0, 7),
    macro_f_string_static_t_initialize("oug-xwr", 0, 7),
    macro_f_string_static_t_initialize("oug-xrw", 0, 7),
    macro_f_string_static_t_initialize("oug=rwx", 0, 7),
    macro_f_string_static_t_initialize("oug=wrx", 0, 7),
    macro_f_string_static_t_initialize("oug=wxr", 0, 7),
    macro_f_string_static_t_initialize("oug=rxw", 0, 7),
    macro_f_string_static_t_initialize("oug=wxr", 0, 7),
    macro_f_string_static_t_initialize("oug=xwr", 0, 7),
    macro_f_string_static_t_initialize("oug=xrw", 0, 7),
    macro_f_string_static_t_initialize("uog+rwx", 0, 7),
    macro_f_string_static_t_initialize("uog+wrx", 0, 7),
    macro_f_string_static_t_initialize("uog+wxr", 0, 7),
    macro_f_string_static_t_initialize("uog+rxw", 0, 7),
    macro_f_string_static_t_initialize("uog+wxr", 0, 7),
    macro_f_string_static_t_initialize("uog+xwr", 0, 7),
    macro_f_string_static_t_initialize("uog+xrw", 0, 7),
    macro_f_string_static_t_initialize("uog-rwx", 0, 7),
    macro_f_string_static_t_initialize("uog-wrx", 0, 7),
    macro_f_string_static_t_initialize("uog-wxr", 0, 7),
    macro_f_string_static_t_initialize("uog-rxw", 0, 7),
    macro_f_string_static_t_initialize("uog-wxr", 0, 7),
    macro_f_string_static_t_initialize("uog-xwr", 0, 7),
    macro_f_string_static_t_initialize("uog-xrw", 0, 7),
    macro_f_string_static_t_initialize("uog=rwx", 0, 7),
    macro_f_string_static_t_initialize("uog=wrx", 0, 7),
    macro_f_string_static_t_initialize("uog=wxr", 0, 7),
    macro_f_string_static_t_initialize("uog=rxw", 0, 7),
    macro_f_string_static_t_initialize("uog=wxr", 0, 7),
    macro_f_string_static_t_initialize("uog=xwr", 0, 7),
    macro_f_string_static_t_initialize("uog=xrw", 0, 7),
  };

  f_file_mode_t modes[] = {
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
  };

  uint8_t replaces[] = {
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
  };

  for (int i = 0; i < 558; ++i) {

    f_file_mode_t mode = 0;
    uint8_t replace = 0;

    const f_status_t status = f_file_mode_from_string(codes[i], 0, &mode, &replace);

    assert_int_equal(status, F_none);
    assert_int_equal(mode, modes[i]);
    assert_int_equal(replace, replaces[i]);
  } // for
}

void test__f_file_mode_from_string__works_basic_digit(void **state) {

  f_string_static_t codes[] = {
    macro_f_string_static_t_initialize("0", 0, 1),
    macro_f_string_static_t_initialize("1", 0, 1),
    macro_f_string_static_t_initialize("2", 0, 1),
    macro_f_string_static_t_initialize("3", 0, 1),
    macro_f_string_static_t_initialize("4", 0, 1),
    macro_f_string_static_t_initialize("5", 0, 1),
    macro_f_string_static_t_initialize("6", 0, 1),
    macro_f_string_static_t_initialize("7", 0, 1),
    macro_f_string_static_t_initialize("111", 0, 3),
    macro_f_string_static_t_initialize("222", 0, 3),
    macro_f_string_static_t_initialize("333", 0, 3),
    macro_f_string_static_t_initialize("444", 0, 3),
    macro_f_string_static_t_initialize("555", 0, 3),
    macro_f_string_static_t_initialize("666", 0, 3),
    macro_f_string_static_t_initialize("777", 0, 3),
    macro_f_string_static_t_initialize("100", 0, 3),
    macro_f_string_static_t_initialize("200", 0, 3),
    macro_f_string_static_t_initialize("300", 0, 3),
    macro_f_string_static_t_initialize("400", 0, 3),
    macro_f_string_static_t_initialize("500", 0, 3),
    macro_f_string_static_t_initialize("600", 0, 3),
    macro_f_string_static_t_initialize("700", 0, 3),
    macro_f_string_static_t_initialize("010", 0, 3),
    macro_f_string_static_t_initialize("020", 0, 3),
    macro_f_string_static_t_initialize("030", 0, 3),
    macro_f_string_static_t_initialize("040", 0, 3),
    macro_f_string_static_t_initialize("050", 0, 3),
    macro_f_string_static_t_initialize("060", 0, 3),
    macro_f_string_static_t_initialize("070", 0, 3),
    macro_f_string_static_t_initialize("001", 0, 3),
    macro_f_string_static_t_initialize("002", 0, 3),
    macro_f_string_static_t_initialize("003", 0, 3),
    macro_f_string_static_t_initialize("004", 0, 3),
    macro_f_string_static_t_initialize("005", 0, 3),
    macro_f_string_static_t_initialize("006", 0, 3),
    macro_f_string_static_t_initialize("007", 0, 3),
    macro_f_string_static_t_initialize("00000000", 0, 8),
    macro_f_string_static_t_initialize("00000100", 0, 8),
    macro_f_string_static_t_initialize("00000200", 0, 8),
    macro_f_string_static_t_initialize("00000300", 0, 8),
    macro_f_string_static_t_initialize("00000400", 0, 8),
    macro_f_string_static_t_initialize("00000500", 0, 8),
    macro_f_string_static_t_initialize("00000600", 0, 8),
    macro_f_string_static_t_initialize("00000700", 0, 8),
    macro_f_string_static_t_initialize("=0", 0, 2),
    macro_f_string_static_t_initialize("=1", 0, 2),
    macro_f_string_static_t_initialize("=2", 0, 2),
    macro_f_string_static_t_initialize("=3", 0, 2),
    macro_f_string_static_t_initialize("=4", 0, 2),
    macro_f_string_static_t_initialize("=5", 0, 2),
    macro_f_string_static_t_initialize("=6", 0, 2),
    macro_f_string_static_t_initialize("=7", 0, 2),
    macro_f_string_static_t_initialize("=111", 0, 4),
    macro_f_string_static_t_initialize("=222", 0, 4),
    macro_f_string_static_t_initialize("=333", 0, 4),
    macro_f_string_static_t_initialize("=444", 0, 4),
    macro_f_string_static_t_initialize("=555", 0, 4),
    macro_f_string_static_t_initialize("=666", 0, 4),
    macro_f_string_static_t_initialize("=777", 0, 4),
    macro_f_string_static_t_initialize("=100", 0, 4),
    macro_f_string_static_t_initialize("=200", 0, 4),
    macro_f_string_static_t_initialize("=300", 0, 4),
    macro_f_string_static_t_initialize("=400", 0, 4),
    macro_f_string_static_t_initialize("=500", 0, 4),
    macro_f_string_static_t_initialize("=600", 0, 4),
    macro_f_string_static_t_initialize("=700", 0, 4),
    macro_f_string_static_t_initialize("=010", 0, 4),
    macro_f_string_static_t_initialize("=020", 0, 4),
    macro_f_string_static_t_initialize("=030", 0, 4),
    macro_f_string_static_t_initialize("=040", 0, 4),
    macro_f_string_static_t_initialize("=050", 0, 4),
    macro_f_string_static_t_initialize("=060", 0, 4),
    macro_f_string_static_t_initialize("=070", 0, 4),
    macro_f_string_static_t_initialize("=001", 0, 4),
    macro_f_string_static_t_initialize("=002", 0, 4),
    macro_f_string_static_t_initialize("=003", 0, 4),
    macro_f_string_static_t_initialize("=004", 0, 4),
    macro_f_string_static_t_initialize("=005", 0, 4),
    macro_f_string_static_t_initialize("=006", 0, 4),
    macro_f_string_static_t_initialize("=007", 0, 4),
    macro_f_string_static_t_initialize("=00000000", 0, 9),
    macro_f_string_static_t_initialize("=00000100", 0, 9),
    macro_f_string_static_t_initialize("=00000200", 0, 9),
    macro_f_string_static_t_initialize("=00000300", 0, 9),
    macro_f_string_static_t_initialize("=00000400", 0, 9),
    macro_f_string_static_t_initialize("=00000500", 0, 9),
    macro_f_string_static_t_initialize("=00000600", 0, 9),
    macro_f_string_static_t_initialize("=00000700", 0, 9),
    macro_f_string_static_t_initialize("+0", 0, 2),
    macro_f_string_static_t_initialize("+1", 0, 2),
    macro_f_string_static_t_initialize("+2", 0, 2),
    macro_f_string_static_t_initialize("+3", 0, 2),
    macro_f_string_static_t_initialize("+4", 0, 2),
    macro_f_string_static_t_initialize("+5", 0, 2),
    macro_f_string_static_t_initialize("+6", 0, 2),
    macro_f_string_static_t_initialize("+7", 0, 2),
    macro_f_string_static_t_initialize("+111", 0, 4),
    macro_f_string_static_t_initialize("+222", 0, 4),
    macro_f_string_static_t_initialize("+333", 0, 4),
    macro_f_string_static_t_initialize("+444", 0, 4),
    macro_f_string_static_t_initialize("+555", 0, 4),
    macro_f_string_static_t_initialize("+666", 0, 4),
    macro_f_string_static_t_initialize("+777", 0, 4),
    macro_f_string_static_t_initialize("+100", 0, 4),
    macro_f_string_static_t_initialize("+200", 0, 4),
    macro_f_string_static_t_initialize("+300", 0, 4),
    macro_f_string_static_t_initialize("+400", 0, 4),
    macro_f_string_static_t_initialize("+500", 0, 4),
    macro_f_string_static_t_initialize("+600", 0, 4),
    macro_f_string_static_t_initialize("+700", 0, 4),
    macro_f_string_static_t_initialize("+010", 0, 4),
    macro_f_string_static_t_initialize("+020", 0, 4),
    macro_f_string_static_t_initialize("+030", 0, 4),
    macro_f_string_static_t_initialize("+040", 0, 4),
    macro_f_string_static_t_initialize("+050", 0, 4),
    macro_f_string_static_t_initialize("+060", 0, 4),
    macro_f_string_static_t_initialize("+070", 0, 4),
    macro_f_string_static_t_initialize("+001", 0, 4),
    macro_f_string_static_t_initialize("+002", 0, 4),
    macro_f_string_static_t_initialize("+003", 0, 4),
    macro_f_string_static_t_initialize("+004", 0, 4),
    macro_f_string_static_t_initialize("+005", 0, 4),
    macro_f_string_static_t_initialize("+006", 0, 4),
    macro_f_string_static_t_initialize("+007", 0, 4),
    macro_f_string_static_t_initialize("+00000000", 0, 9),
    macro_f_string_static_t_initialize("+00000100", 0, 9),
    macro_f_string_static_t_initialize("+00000200", 0, 9),
    macro_f_string_static_t_initialize("+00000300", 0, 9),
    macro_f_string_static_t_initialize("+00000400", 0, 9),
    macro_f_string_static_t_initialize("+00000500", 0, 9),
    macro_f_string_static_t_initialize("+00000600", 0, 9),
    macro_f_string_static_t_initialize("+00000700", 0, 9),
    macro_f_string_static_t_initialize("-0", 0, 2),
    macro_f_string_static_t_initialize("-1", 0, 2),
    macro_f_string_static_t_initialize("-2", 0, 2),
    macro_f_string_static_t_initialize("-3", 0, 2),
    macro_f_string_static_t_initialize("-4", 0, 2),
    macro_f_string_static_t_initialize("-5", 0, 2),
    macro_f_string_static_t_initialize("-6", 0, 2),
    macro_f_string_static_t_initialize("-7", 0, 2),
    macro_f_string_static_t_initialize("-111", 0, 4),
    macro_f_string_static_t_initialize("-222", 0, 4),
    macro_f_string_static_t_initialize("-333", 0, 4),
    macro_f_string_static_t_initialize("-444", 0, 4),
    macro_f_string_static_t_initialize("-555", 0, 4),
    macro_f_string_static_t_initialize("-666", 0, 4),
    macro_f_string_static_t_initialize("-777", 0, 4),
    macro_f_string_static_t_initialize("-100", 0, 4),
    macro_f_string_static_t_initialize("-200", 0, 4),
    macro_f_string_static_t_initialize("-300", 0, 4),
    macro_f_string_static_t_initialize("-400", 0, 4),
    macro_f_string_static_t_initialize("-500", 0, 4),
    macro_f_string_static_t_initialize("-600", 0, 4),
    macro_f_string_static_t_initialize("-700", 0, 4),
    macro_f_string_static_t_initialize("-010", 0, 4),
    macro_f_string_static_t_initialize("-020", 0, 4),
    macro_f_string_static_t_initialize("-030", 0, 4),
    macro_f_string_static_t_initialize("-040", 0, 4),
    macro_f_string_static_t_initialize("-050", 0, 4),
    macro_f_string_static_t_initialize("-060", 0, 4),
    macro_f_string_static_t_initialize("-070", 0, 4),
    macro_f_string_static_t_initialize("-001", 0, 4),
    macro_f_string_static_t_initialize("-002", 0, 4),
    macro_f_string_static_t_initialize("-003", 0, 4),
    macro_f_string_static_t_initialize("-004", 0, 4),
    macro_f_string_static_t_initialize("-005", 0, 4),
    macro_f_string_static_t_initialize("-006", 0, 4),
    macro_f_string_static_t_initialize("-007", 0, 4),
    macro_f_string_static_t_initialize("-00000000", 0, 9),
    macro_f_string_static_t_initialize("-00000100", 0, 9),
    macro_f_string_static_t_initialize("-00000200", 0, 9),
    macro_f_string_static_t_initialize("-00000300", 0, 9),
    macro_f_string_static_t_initialize("-00000400", 0, 9),
    macro_f_string_static_t_initialize("-00000500", 0, 9),
    macro_f_string_static_t_initialize("-00000600", 0, 9),
    macro_f_string_static_t_initialize("-00000700", 0, 9),
  };

  f_file_mode_t modes[] = {
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
  };

  uint8_t replaces[] = {
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
  };

  for (int i = 0; i < 176; ++i) {

    f_file_mode_t mode = 0;
    uint8_t replace = 0;

    const f_status_t status = f_file_mode_from_string(codes[i], 0, &mode, &replace);

    assert_int_equal(status, F_none);
    assert_int_equal(mode, modes[i]);
    assert_int_equal(replace, replaces[i]);
  } // for
}

#ifdef __cplusplus
} // extern "C"
#endif
